## gammaray 2.11.3

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the GammaRay project.
#
# Pass the following variables to cmake to control the build:
# (See Install.txt for more information)
#
# -DGAMMARAY_BUILD_UI=[true|false]
#  Build the client and in-process UI.
#  Default=true (except on QNX and Android)
#
# -DGAMMARAY_PROBE_ONLY_BUILD=[true|false]
#  Build only an additional probe configuration for an already existing launcher.
#  Default=false
#
# -DGAMMARAY_CLIENT_ONLY_BUILD=[true|false]
#  Build the client part only.
#  Default=false
#
# -DGAMMARAY_ENABLE_GPL_ONLY_FEATURES=[true|false]
#  Enable features only available under GPL license.
#  Default=false
#
# -DGAMMARAY_INSTALL_QT_LAYOUT=[true|false]
#  Install GammaRay in Qt folder using Qt layout folders:
#    - plugins will go in <qt_folder>/plugins/gammaray
#    - all the other libs, including probe library will go in <qt_folder>/lib
#    - qmake mkspecs file
#  Default=false
#  Only use for Android or when you know what you are doing.
#
# -DGAMMARAY_BUILD_CLI_INJECTOR=[true|false]
#  Build the cli injector on Windows
#  Default=true
#
# -DGAMMARAY_MULTI_BUILD=[true|false]
#  Build multiple applicable probe configurations.
#  Default=true
#
# -DGAMMARAY_STATIC_PROBE=[true|false]
#  Build the probe as static library for compile-time injection
#  Default=false
#
# -DGAMMARAY_BUILD_DOCS=[true|false]
#  Build the API documentation and User Manual.
#  Default=true (except when building the probe only)

# -DGAMMARAY_ENFORCE_QT_ASSERTS=[true|false]
#  Force QT_ASSERT in all builds.
#  Default=false
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# The man page is not available on Windows.
#

cmake_minimum_required(VERSION 3.4.0)

cmake_policy(SET CMP0020 NEW)
cmake_policy(SET CMP0043 NEW)
if(POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW)
endif()
if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0068)
  cmake_policy(SET CMP0068 NEW)
endif()
if(POLICY CMP0076)
  cmake_policy(SET CMP0076 NEW)
endif()

project(GammaRay CXX C)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT DEFINED CMAKE_SKIP_BUILD_RPATH)
  set(CMAKE_SKIP_BUILD_RPATH ON)
endif()
if(NOT DEFINED CMAKE_BUILD_WITH_INSTALL_RPATH)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif()
if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()
if(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH TRUE)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSymbolExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(CTest)
include(GammaRayMacros)
include(GammaRayMacrosInternal)
include(FeatureSummary)
set(KDE_INSTALL_USE_QT_SYS_PATHS OFF)
include(ECMGeneratePriFile)
include(ECMEnableSanitizers)
include(GenerateExportHeader)
include("3rdparty/backward-cpp/BackwardConfig.cmake")

# Exit for blacklisted compilers (those that don't support C++11 very well)
#  MSVC++ < 2013 aka 1800
#  Clang 3.1
set(BAD_CXX_MESSAGE "")
if(MSVC)
  if(MSVC_VERSION LESS 1800)
    set(BAD_CXX_MESSAGE "MSVC 2013 or higher")
  endif()
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.1.0)
    set(BAD_CXX_MESSAGE "Clang v3.1.0 or higher")
  endif()
endif()
if(BAD_CXX_MESSAGE)
  message(FATAL_ERROR "\nSorry, ${BAD_CXX_MESSAGE} is required to build this software. Please retry using a modern compiler that supports C++11.")
endif()

if(MSVC AND MSVC_VERSION VERSION_EQUAL 1800)
  # MSVC 2013 implements some C++11 features only partially, which is why cmake
  # doesn't list these features as supported, still support is good enough for us.
  set(GAMMARAY_REQUIRED_CXX_FEATURES
            cxx_lambdas cxx_nullptr cxx_range_for cxx_raw_string_literals cxx_uniform_initialization
            cxx_variadic_templates cxx_rvalue_references cxx_defaulted_functions
            cxx_override cxx_final
  )
else()
  set(GAMMARAY_REQUIRED_CXX_FEATURES
            cxx_lambdas cxx_nullptr cxx_range_for cxx_raw_string_literals cxx_uniform_initialization
            cxx_variadic_templates cxx_rvalue_references cxx_defaulted_functions cxx_deleted_functions
            cxx_override cxx_final cxx_nonstatic_member_init
  )
endif()

# Version setup
set(GAMMARAY_VERSION_MAJOR "2")
set(GAMMARAY_VERSION_MINOR "11")
set(GAMMARAY_VERSION_PATCH "3")
set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
set(GAMMARAY_SOVERSION "2.11.3")
set(GAMMARAY_PLUGIN_VERSION "2.11")
set(PROJECT_VERSION_STRING "${GAMMARAY_VERSION_STRING}")
if(ANDROID)
  # non-rooted Android doesn't like .so versions and requires the lib prefix
  set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES PREFIX "lib")
else()
  set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES SOVERSION ${GAMMARAY_SOVERSION} VERSION ${GAMMARAY_SOVERSION})
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Determine exact build version.")
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray-version.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray-version.h
)

message(STATUS "Building GammaRay ${GAMMARAY_VERSION_STRING} in ${CMAKE_BUILD_TYPE} mode")

#
# Build options
#
set(GAMMARAY_BUILD_UI_DEFAULT ON)
if(QNXNTO OR ANDROID)
  set(GAMMARAY_BUILD_UI_DEFAULT OFF)
endif()

gammaray_option(
  GAMMARAY_PROBE_ONLY_BUILD
  "Build only an additional probe configuration for an already existing launcher."
  OFF
)

gammaray_option(
  GAMMARAY_CLIENT_ONLY_BUILD
  "Build the client part only."
  OFF
)

if(GAMMARAY_CLIENT_ONLY_BUILD)
  set(GAMMARAY_BUILD_UI_DEFAULT ON)
endif()

gammaray_option(GAMMARAY_BUILD_UI "Build the GammaRay client and in-process UI." ${GAMMARAY_BUILD_UI_DEFAULT})

if(GAMMARAY_PROBE_ONLY_BUILD AND GAMMARAY_CLIENT_ONLY_BUILD)
  message(FATAL_ERROR "You can only use one of the *ONLY* option.")
endif()

gammaray_option(GAMMARAY_ENABLE_GPL_ONLY_FEATURES "Enable features only available under GPL license." OFF)
gammaray_option(GAMMARAY_INSTALL_QT_LAYOUT "Install into Qt directory layout." OFF)
gammaray_option(GAMMARAY_MULTI_BUILD "Build multiple applicable probe configurations." ON)
gammaray_option(GAMMARAY_BUILD_CLI_INJECTOR "Build command line injector on Windows." ON)

set(GAMMARAY_BUILD_DOCS_DEFAULT ON)
set(GAMMARAY_DISABLE_FEEDBACK_DEFAULT OFF)
if(GAMMARAY_PROBE_ONLY_BUILD OR CMAKE_CROSSCOMPILING)
  set(GAMMARAY_BUILD_DOCS_DEFAULT OFF)
  set(GAMMARAY_DISABLE_FEEDBACK_DEFAULT ON)
endif()
gammaray_option(GAMMARAY_BUILD_DOCS "Build GammaRay documentation." ${GAMMARAY_BUILD_DOCS_DEFAULT})
gammaray_option(
  GAMMARAY_STATIC_PROBE
  "Build the probe as static library for compile-time injection."
  OFF
)

gammaray_option(
  GAMMARAY_ENFORCE_QT_ASSERTS
  "Force QT_ASSERT in all builds."
  OFF
)

gammaray_option(GAMMARAY_DISABLE_FEEDBACK "Disable user feedback support." ${GAMMARAY_DISABLE_FEEDBACK_DEFAULT})

#
# Static probe setup
#
if(GAMMARAY_STATIC_PROBE)
  set(GAMMARAY_BUILD_UI OFF)
  set(GAMMARAY_PROBE_ONLY_BUILD ON)

  set(GAMMARAY_LIBRARY_TYPE STATIC)
  set(GAMMARAY_PLUGIN_TYPE STATIC)
else()
  set(GAMMARAY_LIBRARY_TYPE SHARED)
  set(GAMMARAY_PLUGIN_TYPE MODULE)
endif()

#
# Compiler & linker settings
#
function(append_if condition value)
  if(${condition})
    foreach(variable ${ARGN})
      set(${variable} "${${variable}} ${value}" PARENT_SCOPE)
    endforeach()
  endif()
endfunction()

macro(add_flag_if_supported flag name)
  check_c_compiler_flag("-Werror ${flag}" "C_SUPPORTS_${name}")
  append_if("C_SUPPORTS_${name}" "${flag}" CMAKE_C_FLAGS)
  check_cxx_compiler_flag("-Werror ${flag}" "CXX_SUPPORTS_${name}")
  append_if("CXX_SUPPORTS_${name}" "${flag}" CMAKE_CXX_FLAGS)
endmacro()

function(check_private_headers_exist module)
  message(STATUS "Checking whether private include directories for module ${module} exist")
  # backward compatibility with Qt < 5.9
  if(TARGET Qt5::${module}Private)
    get_target_property(private_includes Qt5::${module}Private INTERFACE_INCLUDE_DIRECTORIES)
    set(Qt5${module}_PRIVATE_INCLUDE_DIRS "${private_includes}" PARENT_SCOPE)
  endif()

  # HACK to work around broken Qt cmake configurations in older Qt version (up to 5.7 at least)
  if(NOT "${Qt5${module}_PRIVATE_INCLUDE_DIRS}" MATCHES "/Qt${module}/")
    string(REPLACE "/QtCore" "/Qt${module}" replaceme "${Qt5Core_PRIVATE_INCLUDE_DIRS}")
    list(APPEND Qt5${module}_PRIVATE_INCLUDE_DIRS ${replaceme})
    list(REMOVE_DUPLICATES Qt5${module}_PRIVATE_INCLUDE_DIRS)
    set(Qt5${module}_PRIVATE_INCLUDE_DIRS ${Qt5${module}_PRIVATE_INCLUDE_DIRS} PARENT_SCOPE)
  endif()

  foreach(dir ${Qt5${module}_PRIVATE_INCLUDE_DIRS})
    if(NOT EXISTS "${dir}")
      message(FATAL_ERROR "The private include directory ${dir} for module ${module} do not exist! Please make sure your Qt5 installation contains private headers.\nThe required directories:\n  ${Qt5${module}_PRIVATE_INCLUDE_DIRS}")
    endif()
  endforeach()
endfunction()

function(check_private_header_exists module file)
  set(found FALSE)
  foreach(dir ${Qt5${module}_PRIVATE_INCLUDE_DIRS})
    if(EXISTS "${dir}/${file}")
      set(found TRUE)
    endif()
  endforeach()
  if(NOT found)
    message(FATAL_ERROR "The private include file ${file} was not found in directory ${Qt5${module}_PRIVATE_INCLUDE_DIRS}! Please make sure your Qt5 installation contains private headers.")
  endif()
endfunction()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_flag_if_supported(-Wunused-but-set-variable UNUSED_BUT_SET)
  add_flag_if_supported(-Wlogical-op LOGICAL_OP)
  add_flag_if_supported(-Wsizeof-pointer-memaccess POINTER_MEMACCESS)
  add_flag_if_supported(-Wreorder REORDER)
  add_flag_if_supported(-Wformat-security FORMAT_SECURITY)

  check_cxx_compiler_flag(-std=gnu++0x HAVE_GXX_GNUXX11)
  check_cxx_compiler_flag(-std=c++0x HAVE_GXX_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wundef -Wpointer-arith -Wmissing-noreturn -Werror=return-type -Wswitch")
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # -Wgnu-zero-variadic-macro-arguments (part of -pedantic) is triggered by every qCDebug() call and therefore results
    # in a lot of noise. This warning is only notifying us that clang is emulating the GCC behaviour
    # instead of the exact standard wording so we can safely ignore it
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu-zero-variadic-macro-arguments")
  endif()
  if(HAVE_GXX_GNUXX11) # QNX needs gnu++0x rather than c++0x for compiling QML V4 private headers
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
  elseif(HAVE_GXX_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
  if(MINGW)
    # mingw will error out on the crazy casts in probe.cpp without this
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
  endif()
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments -Wdocumentation")
endif()
if(CMAKE_C_COMPILER_ID MATCHES "Clang")

=== app/CMakeLists.txt ===
# Integrated launcher/client for Mac app bundles
if(APPLE)
  if(NOT GAMMARAY_INSTALL_QT_LAYOUT)
    # CMake does not allow to have a bundle executable having a name different then the bundle folder name...
    # So we are disabling the bundle behavior here and generate a standard binary
    # The bundle structure will be auto created from the different INSTALL_XXX variables and we only manually generate
    # the Info.plist file

    set(gammaray_app_srcs main.cpp)

    add_executable(gammaray-app ${gammaray_app_srcs})

    target_link_libraries(gammaray-app
      Qt5::Gui Qt5::Widgets
      gammaray_common
      gammaray_launcher
      gammaray_launcher_ui
      gammaray_client
    )

    set_target_properties(gammaray-app PROPERTIES
      OUTPUT_NAME "GammaRayUI"
      INSTALL_RPATH "@executable_path/../Frameworks"
    )

    # Let generate our Info.plist file...
    set(GAMMARAY_BUNDLE_INFO_PLIST_IN "${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in")
    set(GAMMARAY_BUNDLE_INFO_PLIST_OUT "${PROJECT_BINARY_DIR}/${BUNDLE_INSTALL_DIR}/${BUNDLE_APP_NAME}/Contents/Info.plist")

    set(GAMMARAY_BUNDLE_GUI_IDENTIFIER "com.kdab.gammaray")
    set(GAMMARAY_BUNDLE_EXECUTABLE "GammaRayUI")
    set(GAMMARAY_BUNDLE_BUNDLE_NAME "GammaRay")
    set(GAMMARAY_BUNDLE_ICON_FILE "GammaRay.icns")
    set(GAMMARAY_BUNDLE_BUNDLE_VERSION "${GAMMARAY_VERSION}")
    set(GAMMARAY_BUNDLE_SHORT_VERSION_STRING "${GAMMARAY_VERSION}")
    set(GAMMARAY_BUNDLE_LONG_VERSION_STRING "${GAMMARAY_VERSION_STRING}")
    set(GAMMARAY_BUNDLE_INFO_STRING "GammaRay ${GAMMARAY_VERSION}")
    set(GAMMARAY_BUNDLE_COPYRIGHT "Copyright (C) 2010-2021 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com")

    configure_file("${GAMMARAY_BUNDLE_INFO_PLIST_IN}" "${GAMMARAY_BUNDLE_INFO_PLIST_OUT}")

    # Install stuff
    install(TARGETS gammaray-app ${INSTALL_TARGETS_DEFAULT_ARGS})
    install(FILES "${GAMMARAY_BUNDLE_INFO_PLIST_OUT}" DESTINATION "${BUNDLE_INSTALL_DIR}/${BUNDLE_APP_NAME}/Contents")
  endif()
endif()

=== docs/CMakeLists.txt ===
#
# find doc generation tools needed by multiple sub-directories
#

# qdoc toolchain
# TODO: some of this probably should be upstreamed to Qt's cmake files...
# TODO replace with Qt5::qhelpgenerator for Qt >= 5.7.1
find_program(QHELPGEN_EXECUTABLE qhelpgenerator
  HINTS ${QT_INSTALL_BINS}
)
find_program(QDOC_EXECUTABLE qdoc
  HINTS ${QT_INSTALL_BINS}
)
find_program(QTATTRIBUTIONSSCANNER_EXECUTABLE qtattributionsscanner
  HINTS ${QT_INSTALL_BINS}
)

find_file(QDOC_TEMPLATE global/qt-html-templates-offline.qdocconf
  HINTS ${QT_INSTALL_DOCS}
  HINTS ${QT_INSTALL_DATA}
  HINTS ${QT_INSTALL_DATA}/doc
)
find_file(QDOC_QTCORE_INDEX qtcore.index
  HINTS ${QT_INSTALL_DOCS}/qtcore
  HINTS ${QT_INSTALL_DATA}/doc/qtcore
)

if(NOT QDOC_EXECUTABLE OR NOT QHELPGEN_EXECUTABLE OR NOT QDOC_TEMPLATE OR NOT QDOC_QTCORE_INDEX OR NOT QTATTRIBUTIONSSCANNER_EXECUTABLE)
  message(STATUS "Unable to build user manual in qch format.")
  message(STATUS "qdoc executable: ${QDOC_EXECUTABLE}")
  message(STATUS "qhelpgenerator executable: ${QHELPGEN_EXECUTABLE}")
  message(STATUS "qtattributionsscanner executable: ${QTATTRIBUTIONSSCANNER_EXECUTABLE}")
  message(STATUS "qdoc template (qt-html-templates-offline.qdocconf): ${QDOC_TEMPLATE}")
  message(STATUS "qdoc qtcore index (qtcore.index): ${QDOC_QTCORE_INDEX}")
  set(GAMMARAY_USER_MANUAL_BUILD False)
else()
  set(GAMMARAY_USER_MANUAL_BUILD True)
endif()

add_feature_info("User Manual creation in qch format" GAMMARAY_USER_MANUAL_BUILD "Requires qdoc, qhelpgenerator, qtattributionsscanner, the qdoc templates and index files")

# Doxygen
find_package(Doxygen)
set_package_properties(Doxygen PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "API Documentation system"
  URL "https://www.doxygen.org"
  PURPOSE "Needed to build the API documentation."
)
if(DOXYGEN_DOT_EXECUTABLE)
  set(HAVE_DOT "YES")
else()
  set(HAVE_DOT "NO")
  message(STATUS "Unable to provide inheritance diagrams for the API documentation. To fix, install the graphviz project from https://www.graphviz.org")
endif()

if(DOXYGEN_FOUND AND QHELPGEN_EXECUTABLE)
  set(GAMMARAY_API_DOCS_BUILD True)
else()
  set(GAMMARAY_API_DOCS_BUILD False)
endif()

#
# generate docs
#

if(GAMMARAY_API_DOCS_BUILD)
  add_subdirectory(api)
endif()
if(GAMMARAY_USER_MANUAL_BUILD)
  add_subdirectory(manual)
  add_subdirectory(collection)
endif()
add_subdirectory(man)

=== examples/CMakeLists.txt ===
add_subdirectory(quick-batching)
add_subdirectory(quick-event-handling)
add_subdirectory(state-machine)

if(Qt5Widgets_FOUND)
  add_subdirectory(signal-slot)
  add_subdirectory(timer)
  add_subdirectory(widget-layouting)
endif()

if(Qt53DExtras_FOUND)
  add_subdirectory(qt3d-geometry)
endif()

=== tests/CMakeLists.txt ===
# keep test output locally, in the multibuild case
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR})

configure_file(gammaray-test-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/gammaray-test-config.h)

# create intermediate modeltestobj object files which unit tests can use
add_library(modeltestobj OBJECT ${CMAKE_SOURCE_DIR}/3rdparty/qt/modeltest.cpp)
set_target_properties(modeltestobj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(modeltestobj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(modeltestobj PRIVATE $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>) # for -DQT_NAMESPACE=...
target_include_directories(modeltestobj PUBLIC $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>)

# create intermediate test_helpers_obj object files which unit tests can use
add_library(test_helpers_obj OBJECT testhelpers.cpp)
set_target_properties(test_helpers_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(test_helpers_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(test_helpers_obj PRIVATE
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Test,INTERFACE_COMPILE_DEFINITIONS>
) # for -DQT_NAMESPACE=...
target_include_directories(test_helpers_obj PUBLIC
  $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:Qt5::Test,INTERFACE_INCLUDE_DIRECTORIES>
)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
# create intermediate base_probe_test_obj object files which unit tests can use
add_library(base_probe_test_obj OBJECT baseprobetest.h)
set_target_properties(base_probe_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(base_probe_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_include_directories(base_probe_test_obj PUBLIC
  $<TARGET_PROPERTY:gammaray_core,INTERFACE_INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:gammaray_common,INTERFACE_INCLUDE_DIRECTORIES>
)
target_compile_definitions(base_probe_test_obj PRIVATE
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Test,INTERFACE_COMPILE_DEFINITIONS>
) # for -DQT_NAMESPACE=...
target_include_directories(base_probe_test_obj PUBLIC
  $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:Qt5::Test,INTERFACE_INCLUDE_DIRECTORIES>
)

if(Qt5Quick_FOUND)
  # create intermediate base_quick_test_obj object files which unit tests can use
  add_library(base_quick_test_obj OBJECT basequicktest.h)
  set_target_properties(base_quick_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
  target_compile_features(base_quick_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
  target_compile_definitions(base_quick_test_obj PRIVATE
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Test,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Quick,INTERFACE_COMPILE_DEFINITIONS>
  ) # for -DQT_NAMESPACE=...
  target_include_directories(base_quick_test_obj PUBLIC
    $<TARGET_PROPERTY:base_probe_test_obj,INTERFACE_INCLUDE_DIRECTORIES>
  )
  target_include_directories(base_quick_test_obj PUBLIC
    $<TARGET_PROPERTY:Qt5::Quick,INTERFACE_INCLUDE_DIRECTORIES>
  )
endif()
endif()

add_subdirectory(shared)
add_subdirectory(manual)
add_subdirectory(targets)

# plain unit tests
function(gammaray_add_test _name)
  add_executable(${_name} ${ARGN} $<TARGET_OBJECTS:test_helpers_obj>)
  gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
  target_link_libraries(${_name} Qt5::Test)
  add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring probe injection
function(gammaray_add_probe_test _name)
  add_executable(${_name} ${ARGN}
    $<TARGET_OBJECTS:gammaray_probe_obj>
    $<TARGET_OBJECTS:test_helpers_obj>
    $<TARGET_OBJECTS:base_probe_test_obj>
  )
  gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
  target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt5::Test)
  add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring quick and probe injection
function(gammaray_add_quick_test _name)
  add_executable(${_name} ${ARGN}
    $<TARGET_OBJECTS:gammaray_probe_obj>
    $<TARGET_OBJECTS:test_helpers_obj>
    $<TARGET_OBJECTS:base_probe_test_obj>
    $<TARGET_OBJECTS:base_quick_test_obj>
  )
  gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
  target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt5::Test)
  add_test(NAME ${_name} COMMAND ${_name})
endfunction()

### BENCH SUITE

if(Qt5Widgets_FOUND)
  add_executable(benchsuite benchsuite.cpp)
  gammaray_set_rpath(benchsuite ${BIN_INSTALL_DIR})

  target_link_libraries(benchsuite
    Qt5::Core
    Qt5::Gui Qt5::Widgets
    Qt5::Test
    gammaray_common
    gammaray_core
  )

#
# Full-scale injection tests
#
  add_executable(connectiontest test_connections.cpp)
  gammaray_set_rpath(connectiontest ${BIN_INSTALL_DIR})

  target_link_libraries(connectiontest
    Qt5::Core
    Qt5::Gui Qt5::Widgets
    Qt5::Test
  )

endif()

add_executable(attachhelper attachhelper.cpp)
gammaray_set_rpath(attachhelper ${BIN_INSTALL_DIR})

target_link_libraries(attachhelper Qt5::Core)

if(UNIX)
  find_program(GDB_EXECUTABLE gdb)
  find_program(LLDB_EXECUTABLE lldb)
endif()

set(INJECTOR_TYPES)
if(UNIX)
  list(APPEND INJECTOR_TYPES preload style)

  if(GDB_EXECUTABLE)
    list(APPEND INJECTOR_TYPES gdb)
  endif()
  if(LLDB_EXECUTABLE)
    list(APPEND INJECTOR_TYPES lldb)
  endif()
elseif(WIN32)
  list(APPEND INJECTOR_TYPES windll style)
endif()

foreach(injectorType ${INJECTOR_TYPES})
  add_test(connectiontest-${injectorType}
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess --listen tcp://127.0.0.1 -unittest -i ${injectorType}
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
  )
  add_test(connectiontest-${injectorType}-filter
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess -unittest --listen tcp://127.0.0.1 -filtertest -i ${injectorType}
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
  )
  set_tests_properties(connectiontest-${injectorType}-filter PROPERTIES ENVIRONMENT GAMMARAY_TEST_FILTER=1)
endforeach()

#
# common and core unit tests
#
gammaray_add_test(multisignalmappertest multisignalmappertest.cpp ../core/multisignalmapper.cpp)
target_link_libraries(multisignalmappertest Qt5::Gui)

gammaray_add_test(sourcelocationtest sourcelocationtest.cpp)
target_link_libraries(sourcelocationtest Qt5::Gui gammaray_common)

gammaray_add_test(selflocatortest selflocatortest.cpp)
target_link_libraries(selflocatortest Qt5::Gui gammaray_common ${CMAKE_DL_LIBS})

gammaray_add_test(executiontest executiontest.cpp)
target_link_libraries(executiontest Qt5::Gui gammaray_core)

gammaray_add_test(metaobjecttest metaobjecttest.cpp)
target_link_libraries(metaobjecttest gammaray_core)

gammaray_add_probe_test(problemreportertest problemreportertest.cpp $<TARGET_OBJECTS:modeltestobj>)
target_link_libraries(problemreportertest gammaray_core)
if(Qt5Qml_FOUND)
  target_link_libraries(problemreportertest Qt5::Qml)
endif()
if(Qt5Widgets_FOUND)
  target_link_libraries(problemreportertest Qt5::Widgets)
endif()

gammaray_add_test(objectinstancetest objectinstancetest.cpp)
target_link_libraries(objectinstancetest gammaray_core)

gammaray_add_test(propertysyncertest propertysyncertest.cpp)
target_link_libraries(propertysyncertest gammaray_common Qt5::Gui)

gammaray_add_test(propertyadaptortest propertyadaptortest.cpp)
target_link_libraries(propertyadaptortest gammaray_core Qt5::Gui gammaray_shared_test_data)

if(HAVE_QT_WIDGETS)
  gammaray_add_test(enumpropertytest enumpropertytest.cpp)
  target_link_libraries(enumpropertytest gammaray_core Qt5::Gui Qt5::Widgets)
endif()

gammaray_add_probe_test(propertymodeltest propertymodeltest.cpp $<TARGET_OBJECTS:modeltestobj>)
target_link_libraries(propertymodeltest gammaray_core gammaray_shared_test_data)

gammaray_add_test(qmetaobjectvalidatortest qmetaobjectvalidatortest.cpp)
target_include_directories(qmetaobjectvalidatortest SYSTEM PRIVATE ${Qt5Core_PRIVATE_INCLUDE_DIRS})
target_link_libraries(qmetaobjectvalidatortest Qt5::Gui gammaray_core)

if(GAMMARAY_BUILD_UI)
  gammaray_add_test(metatypemodeltest
    metatypemodeltest.cpp
    ${CMAKE_SOURCE_DIR}/core/tools/metatypebrowser/metatypesmodel.cpp
    ${CMAKE_SOURCE_DIR}/ui/tools/metatypebrowser/metatypesclientmodel.cpp
    $<TARGET_OBJECTS:modeltestobj>
  )
  target_link_libraries(metatypemodeltest gammaray_core Qt5::Gui Qt5::Widgets)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
  gammaray_add_probe_test(signalspycallbacktest signalspycallbacktest.cpp)
  target_link_libraries(signalspycallbacktest gammaray_core)
  gammaray_add_probe_test(integrationtest integrationtest.cpp)
  target_link_libraries(integrationtest gammaray_core)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
  gammaray_add_probe_test(multithreadingtest multithreadingtest.cpp)
  target_link_libraries(multithreadingtest gammaray_core)

  if(GAMMARAY_BUILD_UI)
    gammaray_add_probe_test(methodmodeltest
      methodmodeltest.cpp
      ${CMAKE_SOURCE_DIR}/core/objectmethodmodel.cpp
      ${CMAKE_SOURCE_DIR}/core/qmetaobjectvalidator.cpp
      ${CMAKE_SOURCE_DIR}/core/metaobjectregistry.cpp
      ${CMAKE_SOURCE_DIR}/ui/tools/objectinspector/clientmethodmodel.cpp
      $<TARGET_OBJECTS:modeltestobj>
    )
    target_include_directories(methodmodeltest SYSTEM PRIVATE ${Qt5Core_PRIVATE_INCLUDE_DIRS})
    target_link_libraries(methodmodeltest gammaray_core Qt5::Gui Qt5::Widgets)
  endif()
endif()

#
# ui unit tests
#
if(GAMMARAY_BUILD_UI)
  gammaray_add_test(propertybindertest propertybindertest.cpp)
  target_link_libraries(propertybindertest gammaray_ui)

  if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(metaobjecttreemodeltest
      metaobjecttreemodeltest.cpp
      ${CMAKE_SOURCE_DIR}/ui/tools/metaobjectbrowser/metaobjecttreeclientproxymodel.cpp
      $<TARGET_OBJECTS:modeltestobj>
    )
    target_link_libraries(metaobjecttreemodeltest gammaray_core gammaray_ui Qt5::Gui)

    gammaray_add_probe_test(toolmanagertest
      toolmanagertest.cpp
      ../common/toolmanagerinterface.cpp
      $<TARGET_OBJECTS:modeltestobj>
    )
    target_link_libraries(toolmanagertest gammaray_core gammaray_ui Qt5::Network)
  endif()
endif()

#
# launcher unit tests
#
add_executable(sleep sleep.cpp)
target_link_libraries(sleep Qt5::Core)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD AND NOT GAMMARAY_PROBE_ONLY_BUILD)
  gammaray_add_test(probeabitest probeabitest.cpp)
  target_link_libraries(probeabitest gammaray_launcher Qt5::Gui)

  gammaray_add_test(probeabidetectortest probeabidetectortest.cpp)
  target_link_libraries(probeabidetectortest gammaray_launcher Qt5::Gui)

  gammaray_add_test(selftesttest selftesttest.cpp)
  target_link_libraries(selftesttest gammaray_launcher gammaray_common Qt5::Gui)

  gammaray_add_test(earlyexittest earlyexittest.cpp)
  target_include_directories(earlyexittest PRIVATE ${CMAKE_BINARY_DIR}/launcher)
  target_link_libraries(earlyexittest gammaray_core gammaray_launcher)

  if(HAVE_QT_WIDGETS)
    gammaray_add_test(launchertest launchertest.cpp)
    target_include_directories(launchertest PRIVATE ${CMAKE_BINARY_DIR}/launcher)
    target_link_libraries(launchertest gammaray_core gammaray_launcher)
  endif()

  if(TARGET gammaray_client)
    gammaray_add_test(clientconnectiontest clientconnectiontest.cpp)
    target_link_libraries(clientconnectiontest gammaray_core gammaray_launcher gammaray_client)
  endif()
endif()

#
# client unit tests
#

if(NOT GAMMARAY_CLIENT_ONLY_BUILD AND NOT GAMMARAY_PROBE_ONLY_BUILD)
  add_executable(probesettingsclient probesettingsclient.cpp ${CMAKE_SOURCE_DIR}/core/probesettings.cpp)
  target_compile_definitions(probesettingsclient PRIVATE GAMMARAY_CORE_STATIC_DEFINE)
  target_include_directories(probesettingsclient PRIVATE ${CMAKE_BINARY_DIR}/core)

=== 3rdparty/kde/CMakeLists.txt ===
set(gammaray_kitemmodels_srcs
  klinkitemselectionmodel.cpp
  kmodelindexproxymapper.cpp
  krecursivefilterproxymodel.cpp
  kitemmodels_debug.cpp
)

add_library(gammaray_kitemmodels SHARED ${gammaray_kitemmodels_srcs})

target_link_libraries(gammaray_kitemmodels LINK_PUBLIC Qt5::Core)

set_target_properties(gammaray_kitemmodels PROPERTIES
  ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES}
  OUTPUT_NAME gammaray_kitemmodels-${GAMMARAY_PROBE_ABI}
  DEFINE_SYMBOL MAKE_KITEMMODELS_LIB
)
gammaray_set_rpath(gammaray_kitemmodels ${LIB_INSTALL_DIR})

if(NOT GAMMARAY_PROBE_ONLY_BUILD)
  install(TARGETS gammaray_kitemmodels EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})
  if(MSVC)
    install(FILES "$<TARGET_PDB_FILE_DIR:gammaray_kitemmodels>/$<TARGET_PDB_FILE_NAME:gammaray_kitemmodels>" DESTINATION ${BIN_INSTALL_DIR} CONFIGURATIONS Debug RelWithDebInfo)
  endif()

  ecm_generate_pri_file(BASE_NAME GammaRayKItemModels
                        LIB_NAME gammaray_kitemmodels-${GAMMARAY_PROBE_ABI}
                        DEPS "core"
                        FILENAME_VAR PRI_FILENAME
                        INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}
  )

  install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
else()
  install(TARGETS gammaray_kitemmodels ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()

=== docs/collection/CMakeLists.txt ===
if(NOT TARGET Qt5::qcollectiongenerator)
  message(STATUS "qcollectiongenerator not found, documentation collection will not be generated.")
  return()
endif()

set(manual_qch_file ${CMAKE_CURRENT_BINARY_DIR}/../manual/gammaray-manual/gammaray-manual.qch)
set(manual_qch_target gammaray-manual.qch)
if(GAMMARAY_API_DOCS_BUILD)
  set(apidocs_qch_file ${CMAKE_CURRENT_BINARY_DIR}/../api/qch/gammaray-api.qch)
  set(apidocs_qch_target gammaray-api.qch)
  set(API_DOCS_QCH_FILE_TAG "<file>gammaray-api.qch</file>")
else()
  set(apidocs_qch_file ${manual_qch_file}) # trick to make the copy command valid below
  set(apidocs_qch_target ${manual_qch_target})
  set(API_DOCS_QCH_FILE_TAG "")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gammaray.qhcp.cmake ${CMAKE_CURRENT_BINARY_DIR}/gammaray.qhcp)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gammaray.qhc
  COMMAND ${CMAKE_COMMAND} -E copy ${manual_qch_file} ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy ${apidocs_qch_file} ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND Qt5::qcollectiongenerator ${CMAKE_CURRENT_BINARY_DIR}/gammaray.qhcp -o ${CMAKE_CURRENT_BINARY_DIR}/gammaray.qhc
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/gammaray.qhcp.cmake
    ${manual_qch_target}
    ${apidocs_qch_target}
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)
add_custom_target(gammaray_qhc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gammaray.qhc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gammaray.qhc DESTINATION ${QCH_INSTALL_DIR})

=== launcher/cli/CMakeLists.txt ===
# command line launcher
set(gammaray_runner_srcs
  main.cpp
)

gammaray_add_win_icon(gammaray_runner_srcs)

add_executable(gammaray ${gammaray_runner_srcs})

target_link_libraries(gammaray gammaray_launcher gammaray_common)
if(HAVE_QT_WIDGETS)
  target_link_libraries(gammaray Qt5::Gui Qt5::Widgets)
endif()

gammaray_embed_info_plist(gammaray ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)
gammaray_set_rpath(gammaray ${BIN_INSTALL_DIR})

install(TARGETS gammaray ${INSTALL_TARGETS_DEFAULT_ARGS})
if(MSVC)
  install(FILES "$<TARGET_PDB_FILE_DIR:gammaray>/$<TARGET_PDB_FILE_NAME:gammaray>" DESTINATION ${BIN_INSTALL_DIR} CONFIGURATIONS Debug RelWithDebInfo)
endif()

=== plugins/actioninspector/CMakeLists.txt ===
# probe part
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
set(gammaray_actioninspector_plugin_srcs
  actioninspector.cpp
  actionvalidator.cpp
  actionmodel.cpp
)

gammaray_add_plugin(gammaray_actioninspector_plugin
  JSON gammaray_actioninspector.json
  SOURCES ${gammaray_actioninspector_plugin_srcs}
)

target_link_libraries(gammaray_actioninspector_plugin
  Qt5::Gui Qt5::Widgets
  gammaray_core
)
endif()

# ui part
if(GAMMARAY_BUILD_UI)
  set(gammaray_actioninspector_ui_plugin_srcs
    actioninspectorwidget.cpp
    clientactionmodel.cpp
  )

  gammaray_add_plugin(gammaray_actioninspector_ui_plugin
    JSON gammaray_actioninspector.json
    SOURCES ${gammaray_actioninspector_ui_plugin_srcs}
  )

  target_link_libraries(gammaray_actioninspector_ui_plugin
    gammaray_ui
  )
endif()

=== plugins/eventmonitor/CMakeLists.txt ===
# probe part
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)

set(gammaray_eventmonitor_plugin_srcs
  eventmonitor.cpp
  eventmodel.cpp
  eventmonitorinterface.cpp
  eventtypemodel.cpp
  eventtypefilter.cpp
)

gammaray_add_plugin(gammaray_eventmonitor_plugin
  JSON gammaray_eventmonitor.json
  SOURCES ${gammaray_eventmonitor_plugin_srcs}
)

target_include_directories(gammaray_eventmonitor_plugin SYSTEM PRIVATE ${Qt5Core_PRIVATE_INCLUDE_DIRS})
target_link_libraries(gammaray_eventmonitor_plugin
  Qt5::Gui
  gammaray_core
)
endif()

# ui part
if(GAMMARAY_BUILD_UI)
  set(gammaray_eventmonitor_ui_plugin_srcs
    eventmonitorwidget.cpp
    eventmonitorinterface.cpp
    eventmonitorclient.cpp
    eventtypeclientproxymodel.cpp
  )

  gammaray_add_plugin(gammaray_eventmonitor_ui_plugin
    JSON gammaray_eventmonitor.json
    SOURCES ${gammaray_eventmonitor_ui_plugin_srcs}
  )

  target_link_libraries(gammaray_eventmonitor_ui_plugin
    gammaray_ui
  )
endif()

=== plugins/fontbrowser/CMakeLists.txt ===
# probe part
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
set(gammaray_fontbrowser_plugin_srcs
  fontbrowser.cpp
  fontbrowserinterface.cpp
  fontmodel.cpp
  fontdatabasemodel.cpp
  fontbrowserserver.cpp
)

gammaray_add_plugin(gammaray_fontbrowser_plugin
  JSON gammaray_fontbrowser.json
  SOURCES ${gammaray_fontbrowser_plugin_srcs}
)

target_link_libraries(gammaray_fontbrowser_plugin gammaray_core)
target_link_libraries(gammaray_fontbrowser_plugin Qt5::Gui)
endif()

# ui part
if(GAMMARAY_BUILD_UI)

  set(gammaray_fontbrowser_plugin_ui_srcs
    fontbrowserwidget.cpp
    fontbrowserinterface.cpp
    fontbrowserclient.cpp
  )

  gammaray_add_plugin(gammaray_fontbrowser_ui_plugin
    JSON gammaray_fontbrowser.json
    SOURCES ${gammaray_fontbrowser_plugin_ui_srcs}
  )

  target_link_libraries(gammaray_fontbrowser_ui_plugin
    gammaray_common
    gammaray_ui
  )

endif()

=== plugins/mimetypes/CMakeLists.txt ===
# probe plugin
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
set(gammaray_mimetypes_srcs
    mimetypes.cpp
    mimetypesmodel.cpp
)
gammaray_add_plugin(gammaray_mimetypes JSON gammaray_mimetypes.json SOURCES ${gammaray_mimetypes_srcs})
target_link_libraries(gammaray_mimetypes gammaray_core Qt5::Gui gammaray_kitemmodels)
endif()

# ui plugin
if(GAMMARAY_BUILD_UI)
  set(gammaray_mimetypes_ui_srcs
    mimetypeswidget.cpp
  )
  gammaray_add_plugin(gammaray_mimetypes_ui JSON gammaray_mimetypes.json SOURCES ${gammaray_mimetypes_ui_srcs})
  target_link_libraries(gammaray_mimetypes_ui gammaray_ui)
endif()

=== debian/changelog ===
gammaray (2.11.3-3) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * qtwebengine5-dev is now available on mips64el.

  [ Dmitry Shachnev ]
  * Update debian/watch to use GitHub API and add signature verification.
    - Remove no longer needed debian/source/lintian-overrides.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Dmitry Shachnev <mitya57@debian.org>  Thu, 02 Mar 2023 21:03:05 +0300

gammaray (2.11.3-2) unstable; urgency=medium

  * Team upload.
  * Make test failures non-fatal on ppc64el (closes: #1026932).

 -- Dmitry Shachnev <mitya57@debian.org>  Sat, 24 Dec 2022 19:06:21 +0300

gammaray (2.11.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Refresh patches.
  * Update KDAB's copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 21 Apr 2022 18:53:33 -0300

=== debian/control ===
Source: gammaray
Priority: optional
Section: devel
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gdb,
               glslang-tools,
               libgraphviz-dev,
               libkf5coreaddons-dev,
               libkf5syntaxhighlighting-dev,
               libproj-dev,
               libqt5svg5-dev,
               libqt5waylandcompositor5-dev,
               libwayland-dev (>= 1.12.0),
               qml-module-qtqml,
               qml-module-qtquick2,
               qt3d-assimpsceneimport-plugin,
               qt3d-defaultgeometryloader-plugin,
               qt3d-gltfsceneio-plugin,
               qt3d-scene2d-plugin,
               qt3d5-dev (>= 5.14),
               qtbase5-private-dev,
               qtconnectivity5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qtdeclarative5-private-dev,
               qtlocation5-dev,
               qtpositioning5-dev,
               qtscript5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               qttranslations5-l10n,
               qtwayland5,
               qtwebengine5-dev [amd64 arm64 armhf i386 mips64el mipsel],
               xauth,
               xvfb
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/gammaray.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gammaray
Homepage: https://www.kdab.com/development-resources/qt-tools/gammaray/

Package: gammaray
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: qml-module-qt3d,
         qml-module-qtquick-controls,
         qml-module-qtquick-scene3d,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gdb
Description: Tool for examining the internals of Qt application
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.

Package: gammaray-plugin-quickinspector
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml-module-qtquick-controls,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: gammaray
Description: GammaRay plugin for inspecting QtQuick2 applications
 This plugin provides the user with the following inspection and debugging
 facilities:
 .
  * Tree view of all QQuickItems in the scene, marking invisible items
    and items having focus.
  * Object inspector allowing to see all the properties, inspect
    signal-slot connections, and directly invoke slots and Q_INVOKABLE
    methods.
  * Live-preview of the QtQuick scene inside the GammaRay window.
  * Qt Quick scene graph inspector.

Package: gammaray-plugin-waylandinspector
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: Wayland compositor inspector plugin for GammaRay
 The Wayland compositor inspector allows one to browse QWaylandClient
 instances and their associated resources, as well as observe Wayland
 events.

Package: gammaray-plugin-kjobtracker
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: KJob tracker plugin for GammaRay
 This plugin can be used to monitor KJob instances within a KDE-based
 application.

Package: gammaray-plugin-bluetooth
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: QtBluetooth type support for GammaRay
 This plugin adds support for QtBluetooth types into GammaRay.

Package: gammaray-plugin-positioning
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml-module-qtlocation,
         qml-module-qtpositioning,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: gammaray
Description: Qt5Positioning type support for GammaRay
 This plugin adds support for Qt5Positioning types into GammaRay.

Package: gammaray-dev
Architecture: any
Section: libdevel
Depends: gammaray (= ${binary:Version}), ${misc:Depends}
Description: GammaRay plugin development files
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains header files used for building 3rd party GammaRay
 plugins.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_test override_dh_auto_install override_dh_installdocs

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export QT_SELECT=5

# Give the build more time to finish the test suite.
# Timeouts have been appearing on buildd machines for some architectures.
export GAMMARAY_LAUNCHER_TIMEOUT=240

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=FALSE

override_dh_auto_test:
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 i386))
	xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V"
# attachtest-gdb is unstable on s390x and hangs builds
else ifeq ($(DEB_HOST_ARCH), s390x)
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V -E attachtest-gdb"
else
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V"
endif

override_dh_auto_install:
	dh_auto_install
	rm -f debian/tmp/usr/share/doc/gammaray/LICENSE.*

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

=== debian/watch ===
version=4
opts=searchmode=plain,pgpsigurlmangle=s/$/.asc/ \
https://api.github.com/repos/KDAB/GammaRay/releases \
https://github.com/KDAB/GammaRay/releases/download/v[\d.]+/gammaray-([\d.]+)\.tar\.gz

## gammaray 3.1.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,42 +1,47 @@
 Source: gammaray
 Priority: optional
 Section: devel
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                gdb,
                glslang-tools,
                libgraphviz-dev,
-               libkf5coreaddons-dev,
-               libkf5syntaxhighlighting-dev,
+               libkf6coreaddons-dev,
+               libkf6syntaxhighlighting-dev,
                libproj-dev,
-               libqt5svg5-dev,
-               libqt5waylandcompositor5-dev,
                libwayland-dev (>= 1.12.0),
-               qml-module-qtqml,
-               qml-module-qtquick2,
-               qt3d-assimpsceneimport-plugin,
-               qt3d-defaultgeometryloader-plugin,
-               qt3d-gltfsceneio-plugin,
-               qt3d-scene2d-plugin,
-               qt3d5-dev (>= 5.14),
-               qtbase5-private-dev,
-               qtconnectivity5-dev,
-               qtdeclarative5-dev,
-               qtdeclarative5-dev-tools,
-               qtdeclarative5-private-dev,
-               qtlocation5-dev,
-               qtpositioning5-dev,
-               qtscript5-dev,
-               qttools5-dev,
-               qttools5-dev-tools,
-               qttranslations5-l10n,
-               qtwayland5,
-               qtwebengine5-dev [amd64 arm64 armhf i386 mips64el mipsel],
+               qml6-module-qtqml,
+               qml6-module-qtqml-workerscript,
+               qml6-module-qtquick,
+               qml6-module-qtquick-controls,
+               qml6-module-qtquick-templates,
+               qml6-module-qtquick-window,
+               qt6-3d-assimpsceneimport-plugin,
+               qt6-3d-defaultgeometryloader-plugin,
+               qt6-3d-dev,
+               qt6-3d-gltfsceneio-plugin,
+               qt6-3d-scene2d-plugin,
+               qt6-base-private-dev,
+               qt6-connectivity-dev,
+               qt6-declarative-dev,
+               qt6-declarative-dev-tools,
+               qt6-declarative-private-dev,
+               qt6-location-dev,
+               qt6-positioning-dev,
+               qt6-shadertools-dev,
+               qt6-svg-dev,
+               qt6-tools-dev,
+               qt6-tools-dev-tools,
+               qt6-translations-l10n,
+               qt6-wayland,
+               qt6-wayland-dev,
+               qt6-webengine-dev [amd64 arm64 armhf i386],
                xauth,
                xvfb
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/gammaray.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gammaray
 Homepage: https://www.kdab.com/development-resources/qt-tools/gammaray/
@@ -44,9 +49,8 @@
 Package: gammaray
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: qml-module-qt3d,
-         qml-module-qtquick-controls,
-         qml-module-qtquick-scene3d,
+Depends: qml6-module-qtquick-controls,
+         qml6-module-qtquick-scene3d,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: gdb
@@ -61,8 +65,8 @@
 Package: gammaray-plugin-quickinspector
 Architecture: any
 Depends: gammaray (= ${binary:Version}),
-         qml-module-qtquick-controls,
-         qml-module-qtquick2,
+         qml6-module-qtquick,
+         qml6-module-qtquick-controls,
          ${misc:Depends},
          ${shlibs:Depends}
 Enhances: gammaray
@@ -105,14 +109,14 @@
 Package: gammaray-plugin-positioning
 Architecture: any
 Depends: gammaray (= ${binary:Version}),
-         qml-module-qtlocation,
-         qml-module-qtpositioning,
-         qml-module-qtquick2,
+         qml6-module-qtlocation,
+         qml6-module-qtpositioning,
+         qml6-module-qtquick,
          ${misc:Depends},
          ${shlibs:Depends}
 Enhances: gammaray
-Description: Qt5Positioning type support for GammaRay
- This plugin adds support for Qt5Positioning types into GammaRay.
+Description: Qt6Positioning type support for GammaRay
+ This plugin adds support for Qt6Positioning types into GammaRay.
 
 Package: gammaray-dev
 Architecture: any
